/* ===================================================================
 * AddMealForm.java
 * 
 * Copyright (c) 2004 Matt Magoffin. Created Aug 18, 2004 7:03:26 PM.
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: AddMealForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.Course;
import magoffin.matt.ieat.domain.Meal;
import magoffin.matt.ieat.domain.MealRecipe;
import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.UiData;
import magoffin.matt.ieat.domain.UiEdit;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;
import org.springframework.web.servlet.ModelAndView;

/**
 * Controller for adding a new meal.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class AddMealForm extends AbstractEatWizardForm {

	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception 
	{
		UiEdit edit = (UiEdit)command;
		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveMealEdit(model,edit);
		return new ModelAndView(getCancelView(),model);
	}

	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors, int page) throws Exception 
	{
		Map<String, Object> m =  new LinkedHashMap<String, Object>();
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		m.put("uidata",ui);

		List<Course> l = recipeBiz.getAvailableCourses();
		ui.getCourse().addAll(l);
		
		Meal meal = ((UiEdit)command).getMeal();

		// look for any recipe ingredients that must be added
		for ( MealRecipe mr : (List<MealRecipe>)meal.getRecipe() ){
			if ( mr != null && mr.getRecipe() != null && mr.getRecipe().getRecipeId() != null && mr.getRecipe().getRecipeId().intValue() > 0 ) {
				Recipe relatedRecipe = recipeBiz.getRecipeById(mr.getRecipe().getRecipeId());
				ui.getRecipe().add(relatedRecipe);
			}
		}
		return m;
	}
	
	@Override
	protected Object formBackingObject(HttpServletRequest request)
	throws Exception 
	{
		WebUtil.getBizContext(request, true);
		UiEdit edit = getDomainObjectFactory().getUiEditInstance();
		Meal meal = getDomainObjectFactory().getMealInstance();
		edit.setMeal(meal);
		return edit;
	}
	
	@Override
	protected ModelAndView processFinish(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception 
	{
		// store meal in backend!
		UiEdit edit = (UiEdit)command;
		Meal meal = edit.getMeal();
		BizContext context = WebUtil.getBizContext(request, true);
		meal = recipeBiz.storeMeal(meal,context);

		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveMealEdit(model,edit);
		return new ModelAndView(getSuccessView(),model);
	}
	
	@Override
	protected void validatePage(Object command, Errors errors, int page) {
		UiEdit edit = (UiEdit)command;
		Meal meal = edit.getMeal();
		Validator val = getValidator();
		val.validate(meal, errors);
	}
	
}
